﻿

Public Class Form1

  Function MakeString(NamenListe() As Byte,StringNummer As Integer) As String
    MakeString = ""
    Dim i As Integer
    Dim StringFound As Boolean

    Dim aktStringNummer As Integer
    i = 0
    aktStringNummer = 0
    While (aktStringNummer <= StringNummer)
      MakeString = ""
      StringFound = False

      While (i < NamenListe.Length) And StringFound = False
        If (NamenListe(i) <> 0) Then
          MakeString = MakeString & Chr(NamenListe(i))
        Else
          StringFound = True
        End If
        i = i + 1
      End While
      If (MakeString.Length = 0)
        aktStringNummer = StringNummer+1
      End If
      aktStringNummer = aktStringNummer + 1
    End While
  End Function

  Function MakeArray(Name As String) As Byte()
    Dim i As Integer
    i = 0
    Dim NewArray(Name.Length-1) As Byte
    While i < Name.Length
      NewArray.SetValue(Convert.ToByte(Name(i)),i)
      i = i + 1
    End While
    MakeArray = NewArray
  End Function

  Sub CopyArrayTo(Src() As Byte, ByVal SrcOffset As Integer, Dest() As Byte, ByVal DestOffset As Integer, ByVal Len As Integer)
    While Len > 0
      Dest(DestOffset) = Src(SrcOffset)
      DestOffset = DestOffset + 1
      SrcOffset = SrcOffset + 1
      Len = Len - 1
    End While
  End Sub

    Function cNibble(bVal As Byte) As char
      if (bVal > 9)
        cNibble = ChrW(bVal - 10 + &H41)
      else
        cNibble = ChrW(bVal + &H30)
      end if
    End Function



    Function HexNibble(Nibble As char) As byte
      if ((Nibble >= "0") And (Nibble <= "9"))
        HexNibble = AscW(Nibble) - AscW("0")
      else if ((Nibble >= "A") And (Nibble <= "F"))
        HexNibble = AscW(Nibble) - AscW("A") + 10
      else if ((Nibble >= "a") And (Nibble <= "f"))
        HexNibble = AscW(Nibble) - AscW("a") + 10
      else
        HexNibble = 0
      end if 
    End Function


    Function HexByte(HiNibble As char, LoNibble As Char) as byte
      HexByte = HexNibble(LoNibble) + HexNibble(HiNibble) * 16
    End Function

    Function MakeHexString(Arr() As Byte, bShowAsNumber As Boolean) As String
      Dim strLine As String
      Dim lChar As byte
      Dim hChar As byte
      strLine = ""
      Dim i As Integer

      If (bShowAsNUmber) Then
        i = Arr.Length-1

        while (i >= 0)
          lChar = Arr(i) Mod 16
          hChar = ((Arr(i)-lChar)/16) Mod 16

          strLine = strLine + cNibble(hChar)
          strLine = strLine + cNibble(lChar)
          i = i - 1
        end While
      Else
        i = 0

        while (i < Arr.Length)
          lChar = Arr(i) Mod 16
          hChar = ((Arr(i)-lChar)/16) Mod 16

          strLine = strLine + cNibble(hChar)
          strLine = strLine + cNibble(lChar)
          i = i + 1
          If (i < Arr.Length) Then
            strLine = strLine + " "
          End If
        end While

      End If
     
      MakeHexString = strLine
    End Function

    Sub FromHexString(HexString As String , Arr() As Byte, bShowAsNumber As Boolean)
      If (bShowAsNumber) Then
        while (HexString.Length < Arr.Length * 2)
          HexString.Insert(0, "0")
        End While
        Dim i As Integer
        Dim j As Integer
        i = 0
        j = Arr.Length - 1
        While ((j >= 0) And (i < HexString.Length/2))
          Arr(j) = HexByte(HexString(i*2),HexString(i*2+1))
          j = j - 1
          i = i + 1
        End While 
      Else
        HexString = HexString.Replace(" ","")
        while (HexString.Length < Arr.Length * 2)
          HexString = HexString + "0"
        End While
        Dim i As Integer
        Dim j As Integer
        i = 0
        j = 0
        While ((j < Arr.Length) And (i < HexString.Length/2))
          Arr(j) = HexByte(HexString(i*2),HexString(i*2+1))
          j = j + 1
          i = i + 1
        End While 
      End If
    End Sub

    Dim PortHandle As Integer

    Function SelectTransponder() As Boolean
      Dim ErrMsg As String
      Dim UIDBuff(10-1) As Byte 
      Dim ATQA As UInt16
      Dim SAK As Byte
      Dim UIDLen As Integer

      UID.Text = ""

      if (TSHRW_Mifare_Request(PortHandle, ATQA) = -1) Then
        ErrMsg = "Error " + TSHRW_GetLastError(PortHandle).ToString + " at Mifare Request"
        MessageBox.Show(ErrMsg)
        return false
      End If

      UIDLen = TSHRW_Mifare_Select(PortHandle, UIDBuff(0), 10, SAK)
      if (UIDLen < 4) Then
        ErrMsg = "Error " + TSHRW_GetLastError(PortHandle).ToString + " at Mifare Select"
        MessageBox.Show(ErrMsg)
        return false
      End If

      Dim UIDMem(UIDLen-1) As Byte
      CopyArrayTo(UIDBuff, 0, UIDMem, 0, UIDLen)
      UID.Text = MakeHexString(UIDMem,true)

      if ((SAK = &H08) Or (SAK = &H88)) Then
        ' Mifare 1K
        if (Authenticate())
          return true
        End If
      Else If (SAK = &H18)
        ' Mifare 4K
        if (Authenticate())
          return true
        End If
      Else If (SAK = &H00)
        ' Mifare Ultralight
        return true
      Else
        ' Other Chip, not supported by ths application
        ErrMsg = "Unsupported chip type"
        MessageBox.Show(ErrMsg)
        return false
      End If

      return false
    End Function
    
    Function Authenticate() As Boolean
      Dim UIDBuff(7) As Byte

      Dim Key() As Byte = { &HFF, &HFF, &HFF, &HFF, &HFF, &HFF }
      Dim KeyType As Integer

      Dim iBlockNr As Integer
      iBlockNr = Convert.ToInt32(BlockNr.Text)

      KeyType = 0
      ' If either pUID Is Null Pointer or UIDLen is zero, no UID is used at Authenticate.
      ' Don't know how to pass Null Pointer in VB, but UIDLen=0 is enough to skip UID
      if (TSHRW_MifareAuthenticateDirect(PortHandle, UIDBuff(0), 0, KeyType, Key(0), 6, iBlockNr) =TSHRW_NO_ERROR) Then
        return true
      End If
      return false
    End Function

  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
    Dim MaxLen As Integer
    Dim ListLen As Integer
    Dim DevListLen As Integer
    MaxLen = 255
    ListLen = 0
    DevListLen = 0

    Dim DevList(255) As Byte
    Dim NamenListe(1000) As Byte

    DevListLen = TSHRW_ListAllDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSHRW_LanListAllDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSHRW_GetAvailablePorts(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    ListLen = ListLen + 1

    If (ListLen > 1) Then
      Dim DeviceNameArr(255) As Byte
      Dim DeviceName As String
      DeviceName = MakeString(NamenListe, 0)
      DeviceNameArr = MakeArray(DeviceName)

      PortHandle = TSHRW_OpenPort(DeviceNameArr(0), 19200, 500)
      If (PortHandle > 0) Then
        If (TSHRW_IsProgrammer(PortHandle) <> 1) Then
          MessageBox.Show("Device is no Programmer")
        End If
      Else
        PortHandle = 0
      End If

      If (PortHandle <= 0)
        MessageBox.Show("Device could not be opened")
      End If
    End If
  End Sub

  Private Sub Read_Click(sender As Object, e As EventArgs) Handles ReadBtn.Click
    If (PortHandle > 0) Then
      Dim Buffer(16-1) As Byte
      Dim iBlockNr As Integer

      iBlockNr = Convert.ToInt32(BlockNr.Text)
      BlockData.Text = ""

      If (SelectTransponder() = False)
        Return
      End If

      If (TSHRW_MifareRead(PortHandle, iBlockNr, Buffer(0), 16) = 16) Then
        BlockData.Text = MakeHexString(Buffer,false)
      Else
        MessageBox.Show("Read Error")
      End If
    Else
      MessageBox.Show("No Device attached")
    End If
  End Sub

  Private Sub Write_Click(sender As Object, e As EventArgs) Handles WriteBtn.Click
    if (PortHandle > 0) then
      Dim Buffer(16-1) As Byte
      Dim iBlockNr As Integer
        
      FromHexString(BlockData.Text,Buffer,false)
      iBlockNr = Convert.ToInt32(BlockNr.Text)

      If (SelectTransponder() = False)
        Return
      End If

      if (TSHRW_MifareWrite(PortHandle, iBlockNr, Buffer(0), 16) < 0)
        MessageBox.Show("Write Error")
      else
        MessageBox.Show("Write OK")
      End If
    else
      MessageBox.Show("No Device attached")
    End If 
  End Sub

  Private Sub Close_Click(sender As Object, e As EventArgs) Handles CloseBtn.Click
    If (PortHandle > 0)
      TSHRW_ClosePort(PortHandle)
    End If
    Close()
  End Sub

End Class
